"use strict";
var __create = Object.create;
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getProtoOf = Object.getPrototypeOf;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toESM = (mod, isNodeMode, target) => (target = mod != null ? __create(__getProtoOf(mod)) : {}, __copyProps(
  // If the importer is in node compatibility mode or this is not an ESM
  // file that has been converted to a CommonJS file using a Babel-
  // compatible transform (i.e. "__esModule" has not been set), then set
  // "default" to the CommonJS "module.exports" for node compatibility.
  isNodeMode || !mod || !mod.__esModule ? __defProp(target, "default", { value: mod, enumerable: true }) : target,
  mod
));
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);

// src/index.ts
var index_exports = {};
__export(index_exports, {
  computeDiff: () => computeDiff,
  defaultGetDeleteProps: () => defaultGetDeleteProps,
  defaultGetInsertProps: () => defaultGetInsertProps,
  defaultGetUpdateProps: () => defaultGetUpdateProps,
  withGetFragmentExcludeDiff: () => withGetFragmentExcludeDiff
});
module.exports = __toCommonJS(index_exports);

// src/internal/transforms/transformDiffDescendants.ts
var import_plate5 = require("@udecode/plate");
var import_isEqual4 = __toESM(require("lodash/isEqual.js"));

// src/internal/transforms/transformDiffNodes.ts
var import_isEqual = __toESM(require("lodash/isEqual.js"));

// src/internal/utils/copy-without.ts
function copyWithout(obj, w) {
  if (typeof w === "string") {
    w = [w];
  }
  const r = {};
  for (const key in obj) {
    const y = obj[key];
    if (!Array.from(w).includes(key)) {
      r[key] = y;
    }
  }
  return r;
}

// src/internal/transforms/transformDiffNodes.ts
var childrenOnlyStrategy = (node, nextNode, options) => {
  if (node.children != null && nextNode.children != null && (0, import_isEqual.default)(
    copyWithout(node, ["children"]),
    copyWithout(nextNode, ["children"])
  )) {
    const children = computeDiff(
      node.children,
      nextNode.children,
      options
    );
    return [
      {
        ...node,
        children
      }
    ];
  }
  return false;
};
var propsOnlyStrategy = (node, nextNode, { getUpdateProps }) => {
  const properties = {};
  const newProperties = {};
  for (const key in node) {
    if (!(0, import_isEqual.default)(node[key], nextNode[key])) {
      if (key === "children" || key === "text") return false;
      properties[key] = node[key];
      newProperties[key] = nextNode[key];
    }
  }
  for (const key in nextNode) {
    if (node[key] === void 0) {
      if (key === "children" || key === "text") return false;
      newProperties[key] = nextNode[key];
    }
  }
  return [
    {
      ...nextNode,
      ...getUpdateProps(node, properties, newProperties)
    }
  ];
};
var strategies = [childrenOnlyStrategy, propsOnlyStrategy];
function transformDiffNodes(node, nextNode, options) {
  for (const strategy of strategies) {
    const ops = strategy(node, nextNode, options);
    if (ops) {
      return ops;
    }
  }
  return false;
}

// src/internal/transforms/transformDiffTexts.ts
var import_plate3 = require("@udecode/plate");

// src/internal/utils/dmp.ts
var import_diff_match_patch_ts = require("diff-match-patch-ts");
var dmp = new import_diff_match_patch_ts.DiffMatchPatch();
dmp.Diff_Timeout = 0.2;

// src/internal/utils/get-properties.ts
function getProperties(goal, before) {
  const props = {};
  for (const x in goal) {
    if (x !== "text") {
      if (before == null) {
        if (goal[x]) {
          props[x] = goal[x];
        }
      } else {
        if (goal[x] !== before[x]) {
          if (goal[x]) {
            props[x] = goal[x];
          } else {
            props[x] = void 0;
          }
        }
      }
    }
  }
  if (before != null) {
    for (const x in before) {
      if (x !== "text" && goal[x] == null) {
        props[x] = void 0;
      }
    }
  }
  return props;
}

// src/internal/utils/inline-node-char-map.ts
var import_plate = require("@udecode/plate");
var InlineNodeCharMap = class {
  _charGenerator;
  _charToNode = /* @__PURE__ */ new Map();
  constructor({ charGenerator }) {
    this._charGenerator = charGenerator;
  }
  insertBetweenPairs(arr, between) {
    return arr.flatMap((x, i) => {
      if (i === arr.length - 1) return x;
      return [x, between];
    });
  }
  replaceCharWithNode(haystack, needle, replacementNode) {
    return haystack.flatMap((haystackNode) => {
      if (!import_plate.TextApi.isText(haystackNode)) return [haystackNode];
      const splitText = haystackNode.text.split(needle);
      if (splitText.length === 1) return [haystackNode];
      const replacementWithProps = {
        ...replacementNode,
        ...import_plate.NodeApi.extractProps(haystackNode)
      };
      const nodesForTexts = splitText.map((text) => ({
        ...haystackNode,
        text
      }));
      const nodeList = this.insertBetweenPairs(
        nodesForTexts,
        replacementWithProps
      );
      return nodeList.filter((n) => !import_plate.TextApi.isText(n) || n.text.length > 0);
    });
  }
  // Replace non-text nodes with a text node containing a unique char
  nodeToText(node) {
    if (import_plate.TextApi.isText(node)) return node;
    const c = this._charGenerator.next().value;
    this._charToNode.set(c, node);
    return { text: c };
  }
  // Replace chars in text node with original nodes
  textToNode(initialTextNode) {
    let outputNodes = [initialTextNode];
    for (const [c, originalNode] of this._charToNode) {
      outputNodes = this.replaceCharWithNode(outputNodes, c, originalNode);
    }
    return outputNodes;
  }
};

// src/internal/utils/unused-char-generator.ts
function* unusedCharGenerator({
  skipChars = ""
} = {}) {
  const skipSet = new Set(skipChars);
  for (let code = "A".codePointAt(0); ; code++) {
    const c = String.fromCodePoint(code);
    if (skipSet.has(c)) continue;
    yield c;
  }
}

// src/internal/utils/with-change-tracking.ts
var import_plate2 = require("@udecode/plate");
var import_isEqual2 = __toESM(require("lodash/isEqual.js"));
var import_uniqWith = __toESM(require("lodash/uniqWith.js"));
var withChangeTracking = (editor, options) => {
  const e = editor;
  e.propsChanges = [];
  e.insertedTexts = [];
  e.removedTexts = [];
  e.recordingOperations = true;
  const { apply } = e;
  e.apply = (op) => applyWithChangeTracking(e, apply, op);
  e.tf.apply = e.apply;
  e.commitChangesToDiffs = () => commitChangesToDiffs(e, options);
  return e;
};
var applyWithChangeTracking = (editor, apply, op) => {
  if (!editor.recordingOperations) {
    return apply(op);
  }
  withoutRecordingOperations(editor, () => {
    switch (op.type) {
      case "insert_text": {
        applyInsertText(editor, apply, op);
        break;
      }
      case "merge_node": {
        applyMergeNode(editor, apply, op);
        break;
      }
      case "remove_text": {
        applyRemoveText(editor, apply, op);
        break;
      }
      case "set_node": {
        applySetNode(editor, apply, op);
        break;
      }
      case "split_node": {
        applySplitNode(editor, apply, op);
        break;
      }
      default: {
        apply(op);
      }
    }
  });
};
var applyInsertText = (editor, apply, op) => {
  const node = import_plate2.NodeApi.get(editor, op.path);
  apply(op);
  const startPoint = { offset: op.offset, path: op.path };
  const endPoint = { offset: op.offset + op.text.length, path: op.path };
  const range = { anchor: startPoint, focus: endPoint };
  const rangeRef = editor.api.rangeRef(range);
  editor.insertedTexts.push({
    node: {
      ...node,
      text: op.text
    },
    rangeRef
  });
};
var applyRemoveText = (editor, apply, op) => {
  const node = import_plate2.NodeApi.get(editor, op.path);
  apply(op);
  const point = { offset: op.offset, path: op.path };
  const pointRef = editor.api.pointRef(point, {
    affinity: "backward"
  });
  editor.removedTexts.push({
    node: {
      ...node,
      text: op.text
    },
    pointRef
  });
};
var applyMergeNode = (editor, apply, op) => {
  const oldNode = import_plate2.NodeApi.get(editor, op.path);
  const properties = import_plate2.NodeApi.extractProps(oldNode);
  const prevNodePath = import_plate2.PathApi.previous(op.path);
  const prevNode = import_plate2.NodeApi.get(editor, prevNodePath);
  const newProperties = import_plate2.NodeApi.extractProps(prevNode);
  apply(op);
  const startPoint = { offset: prevNode.text.length, path: prevNodePath };
  const endPoint = editor.api.end(prevNodePath);
  const range = { anchor: startPoint, focus: endPoint };
  const rangeRef = editor.api.rangeRef(range);
  editor.propsChanges.push({
    newProperties,
    properties,
    rangeRef
  });
};
var applySplitNode = (editor, apply, op) => {
  const oldNode = import_plate2.NodeApi.get(editor, op.path);
  const properties = import_plate2.NodeApi.extractProps(oldNode);
  const newProperties = op.properties;
  apply(op);
  const newNodePath = import_plate2.PathApi.next(op.path);
  const newNodeRange = editor.api.range(newNodePath);
  const rangeRef = editor.api.rangeRef(newNodeRange);
  editor.propsChanges.push({
    newProperties,
    properties,
    rangeRef
  });
};
var applySetNode = (editor, apply, op) => {
  apply(op);
  const range = editor.api.range(op.path);
  const rangeRef = editor.api.rangeRef(range);
  editor.propsChanges.push({
    newProperties: op.newProperties,
    properties: op.properties,
    rangeRef
  });
};
var commitChangesToDiffs = (editor, { getDeleteProps, getInsertProps, getUpdateProps }) => {
  withoutRecordingOperations(editor, () => {
    const flatUpdates = flattenPropsChanges(editor).reverse();
    flatUpdates.forEach(({ newProperties, properties, range }) => {
      const node = import_plate2.NodeApi.get(editor, range.anchor.path);
      editor.tf.setNodes(getUpdateProps(node, properties, newProperties), {
        at: range,
        marks: true
      });
    });
    editor.removedTexts.forEach(({ node, pointRef }) => {
      const point = pointRef.current;
      if (point) {
        editor.tf.insertNode(
          {
            ...node,
            ...getDeleteProps(node)
          },
          { at: point }
        );
      }
      pointRef.unref();
    });
    editor.insertedTexts.forEach(({ node, rangeRef }) => {
      const range = rangeRef.current;
      if (range) {
        editor.tf.setNodes(getInsertProps(node), {
          at: range,
          marks: true
        });
      }
      rangeRef.unref();
    });
  });
};
var flattenPropsChanges = (editor) => {
  const propChangeRangeRefs = editor.propsChanges.map(
    ({ rangeRef }) => rangeRef
  );
  const insertedTextRangeRefs = editor.insertedTexts.map(
    ({ rangeRef }) => rangeRef
  );
  const unsortedRangePoints = [
    ...propChangeRangeRefs,
    ...insertedTextRangeRefs
  ].flatMap((rangeRef) => {
    const range = rangeRef.current;
    if (!range) return [];
    return [range.anchor, range.focus];
  });
  const rangePoints = (0, import_uniqWith.default)(
    unsortedRangePoints.sort(import_plate2.PointApi.compare),
    import_plate2.PointApi.equals
  );
  if (rangePoints.length < 2) return [];
  const flatRanges = Array.from({ length: rangePoints.length - 1 }).fill(null).map((_, i) => ({
    anchor: rangePoints[i],
    focus: rangePoints[i + 1]
  }));
  const flatUpdates = flatRanges.map((flatRange) => {
    const getIntersectingChanges = (changes) => changes.filter(({ rangeRef }) => {
      const range = rangeRef.current;
      if (!range) return false;
      const intersection = import_plate2.RangeApi.intersection(range, flatRange);
      if (!intersection) return false;
      return import_plate2.RangeApi.isExpanded(intersection);
    });
    if (getIntersectingChanges(editor.insertedTexts).length > 0) return null;
    const intersectingUpdates = getIntersectingChanges(editor.propsChanges);
    if (intersectingUpdates.length === 0) return null;
    const initialProps = objectWithoutUndefined(
      intersectingUpdates[0].properties
    );
    const finalProps = objectWithoutUndefined(
      intersectingUpdates.at(-1).newProperties
    );
    if ((0, import_isEqual2.default)(initialProps, finalProps)) return null;
    const properties = {};
    const newProperties = {};
    for (const key of Object.keys(finalProps)) {
      if (!(0, import_isEqual2.default)(initialProps[key], finalProps[key])) {
        properties[key] = initialProps[key];
        newProperties[key] = finalProps[key];
      }
    }
    for (const key of Object.keys(initialProps)) {
      if (finalProps[key] === void 0) {
        properties[key] = initialProps[key];
        newProperties[key] = void 0;
      }
    }
    return {
      newProperties,
      properties,
      range: flatRange
    };
  });
  propChangeRangeRefs.forEach((rangeRef) => rangeRef.unref());
  return flatUpdates.filter(Boolean);
};
var objectWithoutUndefined = (obj) => {
  const newObj = {};
  Object.keys(obj).forEach((key) => {
    if (obj[key] !== void 0) {
      newObj[key] = obj[key];
    }
  });
  return newObj;
};
var withoutRecordingOperations = (editor, fn) => {
  editor.recordingOperations = false;
  fn();
  editor.recordingOperations = true;
};

// src/internal/transforms/transformDiffTexts.ts
function transformDiffTexts(nodes, nextNodes, options) {
  if (nodes.length === 0) throw new Error("must have at least one nodes");
  if (nextNodes.length === 0)
    throw new Error("must have at least one nextNodes");
  const { lineBreakChar } = options;
  const hasLineBreakChar = lineBreakChar !== void 0;
  const charGenerator = unusedCharGenerator({
    // Do not use any char that is present in the text
    skipChars: nodes.concat(nextNodes).filter(import_plate3.TextApi.isText).map((n) => n.text).join("")
  });
  const insertedLineBreakProxyChar = hasLineBreakChar ? charGenerator.next().value : void 0;
  const deletedLineBreakProxyChar = hasLineBreakChar ? charGenerator.next().value : void 0;
  const inlineNodeCharMap = new InlineNodeCharMap({
    charGenerator
  });
  const texts = nodes.map((n) => inlineNodeCharMap.nodeToText(n));
  const nextTexts = nextNodes.map((n) => inlineNodeCharMap.nodeToText(n));
  const nodesEditor = withChangeTracking((0, import_plate3.createEditor)(), options);
  nodesEditor.children = [{ children: texts, type: import_plate3.BaseParagraphPlugin.key }];
  nodesEditor.tf.withoutNormalizing(() => {
    let node = texts[0];
    if (texts.length > 1) {
      for (let i = 1; i < texts.length; i++) {
        nodesEditor.tf.apply({
          path: [0, 1],
          position: 0,
          // Required by type; not actually used here
          properties: {},
          // Required by type; not actually used here
          type: "merge_node"
        });
        node = { ...node, text: node.text + texts[i].text };
      }
    }
    for (const op of splitTextNodes(node, nextTexts, {
      deletedLineBreakChar: deletedLineBreakProxyChar,
      insertedLineBreakChar: insertedLineBreakProxyChar
    })) {
      nodesEditor.tf.apply(op);
    }
    nodesEditor.commitChangesToDiffs();
  });
  let diffTexts = nodesEditor.children[0].children;
  if (hasLineBreakChar) {
    diffTexts = diffTexts.map((n) => ({
      ...n,
      text: n.text.replaceAll(insertedLineBreakProxyChar, lineBreakChar + "\n").replaceAll(deletedLineBreakProxyChar, lineBreakChar)
    }));
  }
  return diffTexts.flatMap((t) => inlineNodeCharMap.textToNode(t));
}
function slateTextDiff(a, b, { deletedLineBreakChar, insertedLineBreakChar }) {
  const diff = dmp.diff_main(a, b);
  dmp.diff_cleanupSemantic(diff);
  const operations = [];
  let offset = 0;
  let i = 0;
  while (i < diff.length) {
    const chunk = diff[i];
    const op = chunk[0];
    const text = chunk[1];
    switch (op) {
      case -1: {
        operations.push({
          offset,
          text: deletedLineBreakChar === void 0 ? text : text.replaceAll("\n", deletedLineBreakChar),
          type: "remove_text"
        });
        break;
      }
      case 0: {
        offset += text.length;
        break;
      }
      case 1: {
        operations.push({
          offset,
          text: insertedLineBreakChar === void 0 ? text : text.replaceAll("\n", insertedLineBreakChar),
          type: "insert_text"
        });
        offset += text.length;
        break;
      }
    }
    i += 1;
  }
  return operations;
}
function splitTextNodes(node, split, options) {
  if (split.length === 0) {
    return [
      {
        node,
        path: [0, 0],
        type: "remove_node"
      }
    ];
  }
  let splitText = "";
  for (const { text } of split) {
    splitText += text;
  }
  const nodeText = node.text;
  const operations = [];
  if (splitText !== nodeText) {
    for (const op of slateTextDiff(nodeText, splitText, options)) {
      operations.push({ path: [0, 0], ...op });
    }
  }
  const newProperties = getProperties(split[0], node);
  if (getKeysLength(newProperties) > 0) {
    operations.push({
      newProperties,
      path: [0, 0],
      properties: getProperties(node),
      type: "set_node"
    });
  }
  let properties = getProperties(split[0]);
  let splitPath = [0, 0];
  for (let i = 0; i < split.length - 1; i++) {
    const part = split[i];
    const nextPart = split[i + 1];
    const newProps = getProperties(nextPart);
    Object.keys(properties).forEach((key) => {
      if (!newProps.hasOwnProperty(key)) {
        newProps[key] = void 0;
      }
    });
    operations.push({
      path: splitPath,
      position: part.text.length,
      properties: newProps,
      type: "split_node"
    });
    splitPath = import_plate3.PathApi.next(splitPath);
    properties = getProperties(nextPart);
  }
  return operations;
}
function getKeysLength(obj) {
  if (obj == null) {
    return 0;
  }
  return Object.keys(obj).length;
}

// src/internal/utils/diff-nodes.ts
var import_plate4 = require("@udecode/plate");
var import_isEqual3 = __toESM(require("lodash/isEqual.js"));
function diffNodes(originNodes, targetNodes, { elementsAreRelated }) {
  const result = [];
  let relatedNode;
  const leftTargetNodes = [...targetNodes];
  originNodes.forEach((originNode) => {
    let childrenUpdated = false;
    let nodeUpdated = false;
    relatedNode = leftTargetNodes.find((targetNode) => {
      if (import_plate4.ElementApi.isElement(originNode) && import_plate4.ElementApi.isElement(targetNode)) {
        const relatedResult = elementsAreRelated?.(originNode, targetNode) ?? null;
        if (relatedResult !== null) return relatedResult;
      }
      if (isEqualNode(originNode, targetNode)) {
        childrenUpdated = true;
      }
      if (isEqualNodeChildren(originNode, targetNode)) {
        nodeUpdated = true;
      }
      return nodeUpdated || childrenUpdated;
    });
    if (relatedNode) {
      const insertNodes = leftTargetNodes.splice(
        0,
        leftTargetNodes.indexOf(relatedNode)
      );
      insertNodes.forEach((insertNode) => {
        result.push({
          insert: true,
          originNode: insertNode
        });
      });
      leftTargetNodes.splice(0, 1);
    }
    result.push({
      childrenUpdated,
      delete: !relatedNode,
      nodeUpdated,
      originNode,
      relatedNode
    });
  });
  leftTargetNodes.forEach((insertNode) => {
    result.push({
      insert: true,
      originNode: insertNode
    });
  });
  return result;
}
function isEqualNode(value, other) {
  return import_plate4.ElementApi.isElement(value) && import_plate4.ElementApi.isElement(other) && value.children !== null && other.children !== null && (0, import_isEqual3.default)(copyWithout(value, ["children"]), copyWithout(other, ["children"]));
}
function isEqualNodeChildren(value, other) {
  if (import_plate4.ElementApi.isElement(value) && import_plate4.ElementApi.isElement(other) && (0, import_isEqual3.default)(value.children, other.children)) {
    return true;
  }
  return import_plate4.TextApi.isText(value) && import_plate4.TextApi.isText(other) && (0, import_isEqual3.default)(value.text, other.text);
}

// src/internal/transforms/transformDiffDescendants.ts
function transformDiffDescendants(diff, { stringCharMapping, ...options }) {
  const { getDeleteProps, getInsertProps, ignoreProps, isInline } = options;
  let i = 0;
  const children = [];
  let insertBuffer = [];
  let deleteBuffer = [];
  const flushBuffers = () => {
    children.push(...deleteBuffer, ...insertBuffer);
    insertBuffer = [];
    deleteBuffer = [];
  };
  const insertNode = (node) => insertBuffer.push({
    ...node,
    ...getInsertProps(node)
  });
  const deleteNode = (node) => deleteBuffer.push({
    ...node,
    ...getDeleteProps(node)
  });
  const passThroughNodes = (...nodes) => {
    flushBuffers();
    children.push(...nodes);
  };
  const areNodeListsEquivalent = (nodes0, nodes1) => {
    const excludeIgnoreProps = (node) => copyWithout(node, ignoreProps || []);
    const nodesWithoutIgnore0 = nodes0.map(excludeIgnoreProps);
    const nodesWithoutIgnore1 = nodes1.map(excludeIgnoreProps);
    return (0, import_isEqual4.default)(nodesWithoutIgnore0, nodesWithoutIgnore1);
  };
  const isInlineList = (nodes) => nodes.every((node) => import_plate5.TextApi.isText(node) || isInline(node));
  while (i < diff.length) {
    const chunk = diff[i];
    const op = chunk[0];
    const val = chunk[1];
    const nodes = stringCharMapping.stringToNodes(val);
    if (op === 0) {
      passThroughNodes(...nodes);
      i += 1;
      continue;
    }
    if (op === -1) {
      if (i < diff.length - 1 && diff[i + 1][0] === 1) {
        const nextVal = diff[i + 1][1];
        const nextNodes = stringCharMapping.stringToNodes(nextVal);
        if (areNodeListsEquivalent(nodes, nextNodes)) {
          passThroughNodes(...nextNodes);
          i += 2;
          continue;
        }
        if (isInlineList(nodes) && isInlineList(nextNodes)) {
          passThroughNodes(...transformDiffTexts(nodes, nextNodes, options));
          i += 2;
          continue;
        }
        const diffResult = diffNodes(nodes, nextNodes, options);
        diffResult.forEach((item) => {
          if (item.delete) {
            deleteNode(item.originNode);
          }
          if (item.insert) {
            insertNode(item.originNode);
          }
          if (item.relatedNode) {
            const diffNodesResult = transformDiffNodes(
              item.originNode,
              item.relatedNode,
              options
            );
            if (diffNodesResult) {
              passThroughNodes(...diffNodesResult);
            } else {
              deleteNode(item.originNode);
              insertNode(item.relatedNode);
            }
          }
        });
        i += 2;
        continue;
      } else {
        for (const node of nodes) {
          deleteNode(node);
        }
        i += 1;
        continue;
      }
    }
    if (op === 1) {
      for (const node of nodes) {
        insertNode(node);
      }
      i += 1;
      continue;
    }
    throw new Error(
      "transformDiffDescendants: Missing continue statement or unhandled operation"
    );
  }
  flushBuffers();
  return children;
}

// src/internal/utils/string-char-mapping.ts
var import_isEqual5 = __toESM(require("lodash/isEqual.js"));
var StringCharMapping = class {
  _charGenerator = unusedCharGenerator();
  _mappedNodes = [];
  charToNode(c) {
    const entry = this._mappedNodes.find(([_node, c2]) => c2 === c);
    if (!entry) throw new Error(`No node found for char ${c}`);
    return entry[0];
  }
  nodesToString(nodes) {
    return nodes.map(this.nodeToChar.bind(this)).join("");
  }
  nodeToChar(node) {
    for (const [n, c2] of this._mappedNodes) {
      if ((0, import_isEqual5.default)(n, node)) {
        return c2;
      }
    }
    const c = this._charGenerator.next().value;
    this._mappedNodes.push([node, c]);
    return c;
  }
  stringToNodes(s) {
    return s.split("").map(this.charToNode.bind(this));
  }
};

// src/lib/computeDiff.ts
var computeDiff = (doc0, doc1, {
  getDeleteProps = defaultGetDeleteProps,
  getInsertProps = defaultGetInsertProps,
  getUpdateProps = defaultGetUpdateProps,
  ignoreProps,
  isInline = () => false,
  ...options
} = {}) => {
  const stringCharMapping = new StringCharMapping();
  const m0 = stringCharMapping.nodesToString(doc0);
  const m1 = stringCharMapping.nodesToString(doc1);
  const diff = dmp.diff_main(m0, m1);
  return transformDiffDescendants(diff, {
    getDeleteProps,
    getInsertProps,
    ignoreProps,
    isInline,
    stringCharMapping,
    getUpdateProps: (node, properties, newProperties) => {
      if (ignoreProps && Object.keys(newProperties).every((key) => ignoreProps.includes(key)))
        return {};
      return getUpdateProps(node, properties, newProperties);
    },
    ...options
  });
};
var defaultGetInsertProps = () => ({
  diff: true,
  diffOperation: {
    type: "insert"
  }
});
var defaultGetDeleteProps = () => ({
  diff: true,
  diffOperation: {
    type: "delete"
  }
});
var defaultGetUpdateProps = (_node, properties, newProperties) => ({
  diff: true,
  diffOperation: {
    newProperties,
    properties,
    type: "update"
  }
});

// src/lib/withGetFragmentExcludeDiff.ts
var import_cloneDeep = __toESM(require("lodash/cloneDeep.js"));
var withGetFragmentExcludeDiff = ({
  api: { getFragment }
}) => ({
  api: {
    getFragment() {
      const fragment = (0, import_cloneDeep.default)(getFragment());
      const removeDiff = (node) => {
        if ("diff" in node) delete node.diff;
        if ("diffOperation" in node) delete node.diffOperation;
        if ("children" in node)
          node.children.forEach(removeDiff);
      };
      fragment.forEach(removeDiff);
      return fragment;
    }
  }
});
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {
  computeDiff,
  defaultGetDeleteProps,
  defaultGetInsertProps,
  defaultGetUpdateProps,
  withGetFragmentExcludeDiff
});
//# sourceMappingURL=index.js.map